function KZ=Apply(NumFig,delx,dely,KZ)

%setptr(DemoFig, 'watch');
MainFig=gcbf;
%set(MainFig,'Pointer','watch');

h = get(MainFig, 'UserData');
v=get(h.OperationsPop,{'value','String'});
name=deblank(v{2}(v{1},:));
%mask = logical(get(ud.h.MaskImage, 'Cdata'));
figure(NumFig);
orig=getimage;
mask=ones(size(orig));
result = orig;

switch name
case 'Histogram Equalization'
   J = histeq(orig);
   result = J;
  
case 'Lowpass Filter'
   order = 15;
   cutoff = 0.3;
   [f1,f2] = freqspace(order,'meshgrid');
   d = find(f1.^2+f2.^2 < cutoff^2);
   Hd = zeros(order);
  
   Hd(d) = 1;
   % Use hanning(15) as the window.  The window coefficients
   % are inlined to remove dependency on the Signal Processing
   % Toolbox.
   h = fwind1(Hd, ...
           [0.0381 0.1464 0.3087 0.5000 0.6913 0.8536 ...
            0.9619 1.0000 0.9619 0.8536 0.6913 0.5000 ...
            0.3087 0.1464 0.0381]);
   result = roifilt2(h, orig,mask);
   
case 'Median Filter'
   med_orig = medfilt2(orig,[3 3]);
   result = med_orig;
   
case 'Brighten'
   bright_orig = imadjust(orig, [], [.25 1]);
   result = bright_orig;
   
case 'Darken'
   dark_orig = imadjust(orig, [], [0 .75]);
   result = dark_orig;
   
case 'Increase Contrast'
   ic_orig = imadjust(orig, [.25 .75], []);
   result = ic_orig;
   
case 'Decrease Contrast'
   dc_orig = imadjust(orig, [], [.25 .75]);
   result = dc_orig;
   
case 'Boundary Interpolation'
   result = roifill(orig);
   
case 'Wiener'
   s=5;
   eval('orig1=imcontin(orig,s);');
   result=wiener2(orig1,[s,s]);
   [mr,nr]=size(result);
   s2=round(s/2);
result=result(s2+1:mr-s2,s2+1:nr-s2);

case 'Histogr'
   figure,
   imhist(orig)
   
 
case 'Invert'
   result=1-orig;
end

  

   [m,n]=size(result);
X=delx:delx:(n-1)*delx;
Y=dely:dely:(m-1)*dely;
maxres=max(result(:));
KZ=maxres*KZ;
result=result/maxres;
figure, 
ha=axes;
colormap(gray(256));
imshow(X,Y,result);
set(ha,'YDir','normal');
%imgpicmd(X,Y,result);


