% function Four_gui

color=1;
number=1;
number1=2;
screenD=get(0,'ScreenDepth');
if screenD>8
   grayres=256;
else grayres=128;
end
iptsetpref('ImshowTruesize','manual')

MainFig=figure(...
   'Name', ' Image Processing and Analysis',...
   'NumberTitle','off', ...
   'Colormap',gray(grayres));
figpos=get(MainFig,'position');
screensize=get(0,'screenSize');
BtnH=0.12;
BtnWid=0.23;
left1=0.1;
left2=0.4;
left3=0.7;
bott1=0.25;
bott2=0.45;
bott3=0.65;
bott4=0.85;
%==================================================
% The Input Image Button
labelStr='Input Image';
callbackStr='[NFig,delx,dely,KZ]=Stmread(h);';
%callbackStr='[NFig,delx,dely,KZ]=picread_bit(h);';
h.Input=uicontrol('Parent',MainFig, ...
   'Style','pushbutton',...
   'Enable','on', ...
   'Units','normalized', ...
   'String', labelStr, ...
   'Position', [left3,bott4,BtnWid,BtnH], ...
   'Callback',callbackStr);

%===================================================
% The Plane Delete Button
labelStr='Surface Delete';
%callbackStr='set(h.WPl,''Enable'',''on'')';
callbackStr='KZ=PlaneDel(h,delx,dely,KZ);';
h.Plane=uicontrol('Parent',MainFig, ...
   'Style','pushbutton',...
   'Enable','off', ...
   'Units','normalized', ...
   'String', labelStr, ...
   'Position', [left1,bott4+BtnH/2,BtnWid,BtnH/2], ...
   'Callback',callbackStr);
%====================================================
%The Number of points in smoothing matrice(label and text field)
labelpos=[left1,bott4,BtnWid/2,BtnH/3];
hl=uicontrol('Parent',MainFig, ...
   'Style','text', ...
   'Units','normalized', ...
   'Position',labelpos, ...
   'Horiz','left', ...
   'String','Matr.size: ');

%text field
textpos=[left1+BtnWid/2+0.02,bott4,BtnWid/4,BtnH/3];
callbackstr='eval(''vv=numoper;'')';%'winPlane(h.WPl,delx,dely,KZ,NFig);';
h.WPl=uicontrol('Parent',MainFig, ...
   'Style','edit', ...
   'Units','normalized', ...
   'Position',textpos, ...
   'BackgroundColor',[1,1,1], ...
   'Enable','on', ...
   'Horiz','right', ...
   'String','10','UserData',10, ...
   'callback',callbackstr);
%=========================================================
%The Number of Window for Plane Deleting(label and text field)
labelpos=[left1,bott4-BtnH/3-0.01,BtnWid/2,BtnH/3];
hl=uicontrol('Parent',MainFig, ...
   'Style','text', ...
   'Units','normalized', ...
   'Position',labelpos, ...
   'Horiz','left', ...
   'String','Window: ');

%text field
textpos=[left1+BtnWid/2+0.02,bott4-BtnH/3-0.01,BtnWid/4,BtnH/3];
callbackstr='eval(''FigPl=numoper;'')';
h.WinPl=uicontrol('Parent',MainFig, ...
   'Style','edit', ...
   'Units','normalized', ...
   'Position',textpos, ...
   'BackgroundColor',[1,1,1], ...
   'Enable','on', ...
   'Horiz','right', ...
   'String','2','UserData',2, ...
   'callback',callbackstr);
%=========================================================
% The Lines Delete Button
labelStr='Delete Horizontal Lines';
callbackStr='[NFig,KZ]=Delhoriz(NFig,delx,dely,KZ);';
h.Lines=uicontrol('Parent',MainFig, ...
   'Style','pushbutton',...
   'Enable','off', ...
   'Units','normalized', ...
   'String', labelStr, ...
   'Position', [left1,bott3,BtnWid,BtnH], ...
   'Callback',callbackStr);
%=====================================================
% The Fragment Button
labelStr='Fragment';
callbackStr='set(h.WFr,''Enable'',''on'')';
h.Fragm=uicontrol('Parent',MainFig, ...
   'Style','pushbutton',...
   'Enable','off', ...
   'Units','normalized', ...
   'String', labelStr, ...
   'Position', [left2,bott4+BtnH/2,BtnWid,BtnH/2], ...
   'Callback',callbackStr);
%====================================================
%The Number of Window for Fragment(label and text field)
labelpos=[left2,bott4,BtnWid/2,BtnH/3];
hl=uicontrol('Parent',MainFig, ...
   'Style','text', ...
   'Units','normalized', ...
   'Position',labelpos, ...
   'Horiz','left', ...
   'String','Window: ');

%text field
textpos=[left2+BtnWid/2+0.02,bott4,BtnWid/4,BtnH/3];
callbackstr='winfr(h.WFr,delx,dely);';
h.WFr=uicontrol('Parent',MainFig, ...
   'Style','edit', ...
   'Units','normalized', ...
   'Position',textpos, ...
   'BackgroundColor',[1,1,1], ...
   'Enable','off', ...
   'Horiz','right', ...
   'String','2','UserData',2, ...
   'callback',callbackstr);
%=========================================================
% The Profile Button
labelStr='Profile';
callbackStr='set(h.PrFr,''Enable'',''on'')';
h.Prof=uicontrol('Parent',MainFig, ...
   'Style','pushbutton',...
   'Enable','off', ...
   'Units','normalized', ...
   'String', labelStr, ...
   'Position', [left2,bott3+BtnH/2,BtnWid,BtnH/2], ...
   'Callback',callbackStr);

%============================================================
%The Number of Window for Profile(label and text field)
labelpos=[left2,bott3,BtnWid/2,BtnH/3];
hl=uicontrol('Parent',MainFig, ...
   'Style','text', ...
   'Units','normalized', ...
   'Position',labelpos, ...
   'Horiz','left', ...
   'String','Window: ');

%text field
textpos=[left2+BtnWid/2+0.02,bott3,BtnWid/4,BtnH/3];
callbackstr='wnprof(h.PrFr,delx,dely,color,number,KZ);';
h.PrFr=uicontrol('Parent',MainFig, ...
   'Style','edit', ...
   'Units','normalized', ...
   'Position',textpos, ...
   'BackgroundColor',[1,1,1], ...
   'Enable','off', ...
   'Horiz','right', ...
   'String','2','UserData',2, ...
   'callback',callbackstr);
%=========================================================
% The Lighting Button
labelStr='LIGHTING';
callbackStr='set(h.WLig,''Enable'',''on'')';
h.Lig=uicontrol('Parent',MainFig, ...
   'Style','pushbutton',...
   'Enable','off', ...
   'Units','normalized', ...
   'String', labelStr, ...
   'Position', [left3,bott3+BtnH/2,BtnWid,BtnH/2], ...
   'Callback',callbackStr);
%====================================================
%The Number of Window for LIGHTING (label and text field)
labelpos=[left3,bott3,BtnWid/2,BtnH/3];
hl=uicontrol('Parent',MainFig, ...
   'Style','text', ...
   'Units','normalized', ...
   'Position',labelpos, ...
   'Horiz','left', ...
   'String','Window: ');

%text field
textpos=[left3+BtnWid/2+0.02,bott3,BtnWid/4,BtnH/3];
callbackstr='eval(''Stmlight(h.WLig,delx,dely,KZ);'')';
h.WLig=uicontrol('Parent',MainFig, ...
   'Style','edit', ...
   'Units','normalized', ...
   'Position',textpos, ...
   'BackgroundColor',[1,1,1], ...
   'Enable','off', ...
   'Horiz','right', ...
   'String','2','UserData',2, ...
   'callback',callbackstr);
%=========================================================
% white radio button
btnpos=[left2,bott3-0.02-2*BtnH/3,BtnWid,BtnH/3];
cbstr='eval(''color=radioup(1);'')';
h.Btn1=uicontrol('Parent',MainFig, ...
   'Style','radiobutton', ...
   'Units','normalized', ...
   'Position', btnpos, ...
   'String','white', ...
  'value',1,'Userdata',1, ...
   'Callback', cbstr);
%=========================================================
% black button
btnpos1=[left2,bott3-0.03-3*BtnH/3,BtnWid,BtnH/3];
cbstr='eval(''color=radioup(2);'')';
h.Btn2=uicontrol('Parent',MainFig, ...
   'Style','radiobutton', ...
   'Units','normalized', ...
   'Position', btnpos1, ...
   'String','black', ...
   'value',0, ...
   'Callback', cbstr);
%=========================================================

%=========================================================
%The Number of Profile(label and text field)
labelpos=[left2,bott2,BtnWid/2,BtnH/3];
hl=uicontrol('Parent',MainFig, ...
   'Style','text', ...
   'Units','normalized', ...
   'Position',labelpos, ...
   'Horiz','left', ...
   'String','Profile Num.: ');

%text field
textpos=[left2+BtnWid/2+0.02,bott2,BtnWid/4,BtnH/3];
cbstr='eval(''number=numprof;'')';
h.PrNum=uicontrol('Parent',MainFig, ...
   'Style','edit', ...
   'Units','normalized', ...
   'Position',textpos, ...
   'BackgroundColor',[1,1,1], ...
   'Enable','on', ...
   'Horiz','right', ...
   'String','1','UserData' ,1, ...
   'Callback', cbstr);

%================================
% Operations Menu:
operpos=[left3,bott2-0.05+BtnH/2,BtnWid,BtnH/2];
h.OperationsPop = uicontrol('Parent',MainFig, ...
   'Style','popupmenu', ...
   'Units','normalized', ...
'Position',operpos, ...
'String','Histogram Equalization|Lowpass Filter|Median Filter|Brighten|Darken|Increase Contrast|Decrease Contrast|Boundary Interpolation|Wiener|Histogr|Invert', ...
   'Callback','eval(''UpdateOperation'')');
% Text label for Image Menu Popup
hu=uicontrol( 'Parent',MainFig, ...
   'Style','text', ...
   'Units','normalized', ...
   'Position',[left3,bott2+BtnH,BtnWid,BtnH/2], ...
   'String',' OPERATIONS:');

%=========================================================
%The Number of Operation Window(label and text field)
labelpos=[left3,bott1+BtnH/2,BtnWid/2,BtnH/3];
hl=uicontrol('Parent',MainFig, ...
   'Style','text', ...
   'Units','normalized', ...
   'Position',labelpos, ...
   'Horiz','left', ...
   'String','Window: ');

%text field
textpos=[left3+BtnWid/2+0.02,bott1+BtnH/2,BtnWid/4,BtnH/3];
cbstr='eval(''number1=numoper;'')';
h.PrNum=uicontrol('Parent',MainFig, ...
   'Style','edit', ...
   'Units','normalized', ...
   'Position',textpos, ...
   'BackgroundColor',[1,1,1], ...
   'Enable','on', ...
   'Horiz','right', ...
   'String','2','UserData' ,2, ...
   'Callback', cbstr);

%================================
%===================================================
% The Apply operation Button
labelStr='Apply Operation';
callbackStr='eval(''KZ=Apply(number1,delx,dely,KZ);'')';
h.Apply=uicontrol('Parent',MainFig, ...
   'Style','pushbutton',...
   'Enable','off', ...
   'Units','normalized', ...
   'String', labelStr, ...
   'Position', [left3,bott1-0.1,BtnWid,BtnH], ...
   'Callback',callbackStr);
%====================================================


%=====================================================
% The Fourier filtration Button
hu=uicontrol('Parent',MainFig, ...
   'Style','text',...
   'Units','normalized', ...
   'Position', [left1,bott2+BtnH/2,BtnWid,BtnH/2], ...
   'String', 'FOURIER FILTRATION');
      
   %====================================================
%The Number of Window for Fourier(label and text field)
labelpos=[left1,bott2,BtnWid/2,BtnH/3];
hl=uicontrol('Parent',MainFig, ...
   'Style','text', ...
   'Units','normalized', ...
   'Position',labelpos, ...
   'Horiz','left', ...
   'String','Window: ');

%text field
textpos=[left1+BtnWid/2+0.02,bott2,BtnWid/4,BtnH/3];
callbackstr='eval(''FigFour=numoper;'')';
h.WFour=uicontrol('Parent',MainFig, ...
   'Style','edit', ...
   'Units','normalized', ...
   'BackgroundColor',[1,1,1], ...
   'Position',textpos, ...
   'Horiz','right', ...
   'String','2','UserData',2, ...
   'callback',callbackstr);
%=========================================================
% Buton for the Spectrum 
labelStr='Fourier Spectrum';
callbackStr='eval(''[SpecFig,Ps,Templ,F]=Fourier_g(h,delx,dely);'')';
h.Spectrum=uicontrol('Parent',MainFig, ...
   'Style','pushbutton',...
   'Enable','off', ...
   'Units','normalized', ...
   'String', labelStr, ...
   'Position', [left1,bott2-BtnH/2-0.01,BtnWid,BtnH/2], ...
   'Callback',callbackStr);

%=========================================================
% Buton for the Spectrum Section
labelStr='Spectrum Section';
callbackStr='eval(''[SectFig,x,y,klin]=Sect(h,SpecFig,Ps,delx,dely);'')';
h.Section=uicontrol('Parent',MainFig, ...
   'Style','pushbutton',...
   'Enable','off', ...
   'Units','normalized', ...
   'String', labelStr, ...
   'Position', [left1,bott2-BtnH-0.02,BtnWid,BtnH/2], ...
   'Callback',callbackStr);
%=========================================================

%Koefficients for Fourier filtration(label and text field)
labelpos=[left1,bott1-BtnH/2,BtnWid/2,BtnH/3];
hl=uicontrol('Parent',MainFig, ...
   'Style','text', ...
   'Units','normalized', ...
   'Position',labelpos, ...
   'Horiz','left', ...
   'String','    AFR= ');

%text field
textpos=[left1+BtnWid/2+0.02,bott1-BtnH/2,BtnWid/4,BtnH/3];
cbstr='eval(''koef_sec=numoper;'')';
h.Koef=uicontrol('Parent',MainFig, ...
   'Style','edit', ...
   'Units','normalized', ...
   'Position',textpos, ...
   'BackgroundColor',[1,1,1], ...
   'Enable','on', ...
   'Horiz','right', ...
   'String','1','UserData' ,1, ...
   'Callback', cbstr);

%================================
%===================================================
% The  Selective Filter Button
labelStr='Multiband Filter';
callbackStr='eval(''Templ=CreateFil(h,x,y,klin,delx,dely,SpecFig,SectFig,Ps,Templ);'')';
h.Select=uicontrol('Parent',MainFig, ...
   'Style','pushbutton',...
   'Enable','off', ...
   'Units','normalized', ...
   'String', labelStr, ...
   'Position', [left1-0.03,bott1-0.01,BtnWid/2+0.02,BtnH/2], ...
   'Callback',callbackStr);
%====================================================
%===================================================
% The  Band Filter Button
labelStr='Band Filter';
callbackStr='eval(''Templ=BandFil(h,x,y,klin,delx,dely,SpecFig,SectFig,Templ);'')';
h.Band=uicontrol('Parent',MainFig, ...
   'Style','pushbutton',...
   'Enable','off', ...
   'Units','normalized', ...
   'String', labelStr, ...
   'Position', [left1+BtnWid/2,bott1-0.01,BtnWid/2+0.02,BtnH/2], ...
   'Callback',callbackStr);
%====================================================
%===================================================
% The Fourier Horizont. Lines Delete Filter Button
labelStr='Horiz';
callbackStr='eval(''Templ=DelHorFft(h,Templ,SpecFig,delx,dely);'')';
h.Horizfft=uicontrol('Parent',MainFig, ...
   'Style','pushbutton',...
   'Enable','off', ...
   'Units','normalized', ...
   'String', labelStr, ...
   'Position', [left1+BtnWid+0.03,bott1-0.01,BtnWid/3,BtnH+0.02], ...
   'Callback',callbackStr);
%====================================================
%===================================================
% The High Frequency Filter Button
labelStr='High';
callbackStr='eval(''Templ=HighFr(h,Templ,delx,dely);'')';
h.High=uicontrol('Parent',MainFig, ...
   'Style','pushbutton',...
   'Enable','off', ...
   'Units','normalized', ...
   'String', labelStr, ...
   'Position', [left1+3*BtnWid/2,bott1-0.01,BtnWid/3,BtnH+0.02], ...
   'Callback',callbackStr);
%====================================================
%===================================================
% The Filtration executing Button
labelStr='Execute Filtration';
callbackStr='eval(''ExecuteFil(h,Templ,F,delx,dely);'')';
h.Execute=uicontrol('Parent',MainFig, ...
   'Style','pushbutton',...
   'Enable','off', ...
   'Units','normalized', ...
   'String', labelStr, ...
   'Position', [left1+2*BtnWid-0.03,bott1-0.01,2*BtnWid/3,BtnH+0.02], ...
   'Callback',callbackStr);
%====================================================
h.msg=uicontrol( 'Parent',MainFig, ...
   'Style','text', ...
   'Units','normalized', ...
   'Enable','on', ...
   'BackgroundColor',[1,1,1], ...
   'Position',[left1,bott1-BtnH-0.02,1.5*BtnWid,BtnH/2], ...
   'String','Input Amplitude Frequency Response(AFR),  AFR>=0');




set(MainFig,'Userdata', h, 'Visible','on');
set(MainFig,'HandleVisibility','Callback');